""" defworld.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from world import world
from know import know
from thing import thing
from body import body
from mind import mind
from house import house
from event import *
import wtime,mgoal

#If you want to mail annoucements to cyphesis-snapshot, you must first
#subscribe to cyphesis-devel@lists.1ststep.net
#ALL discussion should go to cyphesis@lists.1ststep.net

#To subscribe send message to cyphesis-devel-request@lists.1ststep.net
#with text "subscribe" in the body of message.

def default(debug=0):
    #general things
    w=world()
    if debug: w.analyse_event(event('debug',what='on'))

    human_knowledge=know()
    human_knowledge.add('place','axe','smithy')

    village_height=300
    smithy_xyz=(20,10,village_height+5)
    forest_xyz=(150,-50,village_height-50)

    village_knowledge=know()
    village_knowledge.add('xyz','smithy',smithy_xyz)
    village_knowledge.add('xyz','forest',forest_xyz)

    imag=mgoal.imaginary
    peasant_goals=[
        imag('have a breakfast', 'morning', 'home'),
        imag('have a dinner', 'midday', 'home'),
        imag('have a supper', 'evening', 'home'),
        imag('sleep good night', 'night', 'home'),
        mgoal.build_home]

    class home(house):
        def __init__(self,xyz):
            house.__init__(self,'house','ordinary house','home',xyz=xyz)

    def make_own(target,*args):
        e=[]
        for what in args:
            e.append(event("make",what=what))
            #CHEAT!: when language implemented: use that
            e.append(event("say",target=target,what=what))
        return e

    #farmer
    t=thing('axe','normal axe good for cutting trees','forest',
            xyz=forest_xyz,status=1.0)
    home_xyz=(20,50,village_height)
    h=home(home_xyz)
    farmer_knowledge=know()
    farmer_knowledge.add('xyz','home',home_xyz)
    farmer_knowledge.add('xyz','field',(-100,50,village_height))
    mfarmer=mind('farmer','ordinary farmer','home',
                 age=wtime.years(21),
                 xyz=home_xyz,
                 personal_knowledge=farmer_knowledge,
                 local_knowledge=village_knowledge,
                 common_knowledge=human_knowledge,
                 common_goals=peasant_goals)
    mfarmer.add_goal(imag('sow field', 'spring', 'field'))
    mfarmer.add_goal(imag('tend fields', 'summer', 'field'))
    mfarmer.add_goal(imag('harvest crop', 'autumn', 'field'))
    mfarmer.add_goal(mgoal.cut_something(mfarmer,'chop trees', 'winter', 'forest','axe'))
    farmer=body(mfarmer)
    w.new_events(make_own(farmer,farmer,t,h))

    #smith
    home_xyz=(70,0,village_height)
    h=home(home_xyz)
    smithy=thing('smithy','ordinary smithy','smithy',status=1.0,xyz=smithy_xyz)
    msmith=mind('smith','only smith in village','home',
                age=wtime.years(30),
                personal_knowledge=know(xyz={'home':home_xyz}),
                local_knowledge=village_knowledge,
                common_knowledge=human_knowledge,
                common_goals=peasant_goals)
    msmith.add_goal(mgoal.make_amount("axe",10,"ordinary axe","smithy"))
    smith=body(msmith)
    w.new_events(make_own(smith,smith,h,smithy))
    return w
