""" geometry.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from math import *

def sqr(n): return n*n

def diff((x1,y1,z1), (x2,y2,z2)):
    return (x2-x1),(y2-y1),(z2-z1)

def vector1(v1,v2):
    d=distance(v1,v2)
    dx,dy,dz=diff(v1,v2)
    return dx/d,dy/d,dz/d

def distance((x1,y1,z1), (x2,y2,z2)):
    return sqrt(sqr(x2-x1)+sqr(y2-y1)+sqr(z2-z1))

def distance_from_begin((x1,y1,z1), v2, dist):
    (dx,dy,dz)=vector1((x1,y1,z1),v2)
    return x1+dx*dist, y1+dy*dist, z1+dz*dist
