#!/usr/bin/python

""" server.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import sys,ilu
#sys.path.append('/usr/local/ilu/lib')
from engine import engine,factory

def main(argv):
    if (len(argv) < 2):
            print "Usage:  python server.py SERVER-ID"
            sys.exit(1)

    # Create a kernel server with appropriate server ID, which
    #  is passed in as the first argument

    theServer = ilu.CreateServer (argv[1])

    # Now create an instance of a Factory object on that server,
    #  with the instance handle "theFactory"

    theFactory = factory ("engine", theServer)

    # Now make the Factory object "well-known" by publishing it.

    theFactory.IluPublish()

    # Now we print the string binding handle (the object's name plus
    # its location) of the new instance.

    print "Factory instance published."
    print "Its SBH is '" + theFactory.IluSBH() + "'."

    handle = ilu.CreateLoopHandle()
    ilu.RunMainLoop (handle)


main(sys.argv)
